/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

#define RENDER_WIDTH 320
#define RENDER_HEIGHT 240

extern uint8_t RENDER_FRAME;

/**
 * Initializes the rendering system.
 */
void renderInit(void);

/**
 * Tells the rendering system to actually draw the frame.
 */
void renderDraw(void);

/**
 * Disposes of the rendering system.
 */
void renderDispose(void);

/**
 * Checks if the rendering system should exit.
 * 
 * @return true if the rendering system should exit, false otherwise.
 */
bool_t renderShouldExit();