/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct _entity_t entity_t;

typedef struct {
  uint32_t nothing;
} playerentity_t;

#define PLAYER_ENTITY_ID (UINT32_MAX-1)
#define PLAYER_MOVE_SPEED 1.0f
#define PLAYER_MOVE_SPEED_XY (PLAYER_MOVE_SPEED * 0.70710678118f)

/**
 * Initializes the player and all player-related entities.
 */
void playerInit(void);

/**
 * Initializes the player entity.
 * 
 * @param entity The entity to initialize.
 */
void playerNPCInit(entity_t *entity);

/**
 * Updates the player entity.
 * 
 * @param entity The entity to update.
 */
void playerNPCUpdate(entity_t *entity);