/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "display/render.h"
#include "util/memory.h"
#include "world/chunk.h"
#include "display/scene.h"
#include "world/overworld.h"
#include "input.h"

// Press F5 to compile and run the compiled game.gb in the Emulicous Emulator/Debugger
void main(void) {
  renderInit();
  inputInit();
  
  overworldInit();

  SCENE_CURRENT = SCENE_OVERWORLD;

  while(!renderShouldExit()) {
    RENDER_FRAME++;
    renderDraw();
    
    overworldUpdate();

    // Update input for next frame.
    inputUpdate();
  }
  
  renderDispose();
}