/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "chunk.h"
#include "entity/entity.h"

typedef struct {
  uint32_t id;
  entitytype_t type;
  uint8_t x, y;
  entitydir_t dir;
} chunkentity_t;

typedef struct {
  uint8_t layerBase[CHUNK_TILE_COUNT];
  uint8_t layerOverlay[CHUNK_TILE_COUNT];
  chunkentity_t entities[CHUNK_ENTITY_COUNT_MAX];
} chunkdata_t;